commit 95b4239a13f70e0e05925dbc66cf70741af46b3a
Merge: d7e5814349b f71710579a8
Author: Vadim Yalovets <vadim.yalovets@percona.com>
Date:   Fri Mar 1 21:36:24 2024 +0200

    Merge pull request #5244 from Percona-Lab/release-5.7.44-49
    
    PKG-14 Rework 5.7 tarballs

commit 2ef024ca1a1ce26122bbf62b95a8b7600e93ac3e
Author: Vadim Yalovets <vadim.yalovets@percona.com>
Date:   Tue Mar 12 11:09:45 2024 +0200

    PS-9133 Telemetry metrics show wrong version


commit c643a1242d8bab53d42eab851cba0f25db48dcc5
Merge: 95b4239a13f 2ef024ca1a1
Author: Vadim Yalovets <vadim.yalovets@percona.com>
Date:   Tue Mar 12 15:40:32 2024 +0200

    Merge pull request #5255 from Percona-Lab/release-5.7.44-49
    
    PS-9133 Telemetry metrics show wrong version

commit e9caa047f4f7cd9aea9948923c4693383ea5f390
Author: Varun Nagaraju <varun.nagaraju@percona.com>
Date:   Thu Mar 7 17:05:44 2024 +0530

    PS-9040 Integrate clang-tidy checks for Percona server
    
    https://perconadev.atlassian.net/browse/PS-9040
    
    Add top-level .clang-tidy file, and extra files in
    strings/, mysys/, sql/ and unittest/gunit/.

diff --git a/.clang-tidy b/.clang-tidy
new file mode 100644
index 00000000000..475ee66ad97
--- /dev/null
+++ b/.clang-tidy
@@ -0,0 +1,57 @@
+# Copyright (c) 2024 Percona LLC and/or its affiliates. All rights reserved.
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License, version 2.0,
+# as published by the Free Software Foundation.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License, version 2.0, for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301  USA
+
+Checks:
+  -*,
+  bugprone-*,
+  -bugprone-easily-swappable-parameters,
+  clang-analyzer-*,
+  -clang-diagnostic-unused-function,
+  cppcoreguidelines-*,
+  -cppcoreguidelines-avoid-c-arrays,
+  -cppcoreguidelines-avoid-magic-numbers,
+  -cppcoreguidelines-avoid-non-const-global-variables,
+  -cppcoreguidelines-pro-bounds-constant-array-index,
+  -cppcoreguidelines-pro-bounds-pointer-arithmetic,
+  -cppcoreguidelines-pro-bounds-array-to-pointer-decay,
+  -cppcoreguidelines-pro-type-vararg,
+  google-*,
+  -google-readability-todo,
+  -google-readability-braces-around-statements,
+  -google-runtime-int,
+  misc-*,
+  -misc-const-correctness,
+  modernize-use-nullptr,
+  llvm-*,
+  -llvm-header-guard,
+  -llvm-include-order,
+  performance-*,
+  readability-*,
+  -readability-braces-around-statements,
+  -readability-named-parameter
+  -readability-redundant-member-init
+
+CheckOptions:
+  - key:        readability-magic-numbers.IgnoredIntegerValues
+    value:      "1;2;3;4;8;9;10;15;32;127;128;240;255"
+  # Allow things like CHARSET_INFO cs;
+  - key:             readability-identifier-length.MinimumParameterNameLength
+    value:           2
+  - key:             readability-identifier-length.MinimumVariableNameLength
+    value:           2
+  - key: readability-function-cognitive-complexity.Threshold
+    value: 50
+
+FormatStyle: "file"
diff --git a/mysys/.clang-tidy b/mysys/.clang-tidy
new file mode 100644
index 00000000000..fd8526ce9e8
--- /dev/null
+++ b/mysys/.clang-tidy
@@ -0,0 +1,29 @@
+# Copyright (c) 2024 Percona LLC and/or its affiliates. All rights reserved.
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License, version 2.0,
+# as published by the Free Software Foundation.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License, version 2.0, for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301  USA
+
+---
+# This is legacy code, so disable some warnings.
+Checks:
+  -bugprone-assignment-in-if-condition,
+  -bugprone-narrowing-conversions,
+  -cppcoreguidelines-owning-memory,
+  -cppcoreguidelines-narrowing-conversions,
+  -cppcoreguidelines-pro-bounds-array-to-pointer-decay,
+  -google-readability-casting,
+  -readability-function-cognitive-complexity,
+  -readability-implicit-bool-conversion
+
+
+InheritParentConfig: true
diff --git a/sql/.clang-tidy b/sql/.clang-tidy
new file mode 100644
index 00000000000..5c37f5b7812
--- /dev/null
+++ b/sql/.clang-tidy
@@ -0,0 +1,20 @@
+# Copyright (c) 2024 Percona LLC and/or its affiliates. All rights reserved.
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License, version 2.0,
+# as published by the Free Software Foundation.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License, version 2.0, for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301  USA
+
+# Disable some warnings for server code
+Checks:
+  -cppcoreguidelines-owning-memory
+
+InheritParentConfig: true
diff --git a/strings/.clang-tidy b/strings/.clang-tidy
new file mode 100644
index 00000000000..1850bfbef89
--- /dev/null
+++ b/strings/.clang-tidy
@@ -0,0 +1,55 @@
+# Copyright (c) 2024 Percona LLC and/or its affiliates. All rights reserved.
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License, version 2.0,
+# as published by the Free Software Foundation.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License, version 2.0, for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301  USA
+
+---
+# This is legacy code, so disable some warnings.
+Checks:
+  -bugprone-assignment-in-if-condition,
+  -bugprone-implicit-widening-of-multiplication-result,
+  -cppcoreguidelines-avoid-c-arrays,
+  -cppcoreguidelines-avoid-goto,
+  -cppcoreguidelines-avoid-magic-numbers,
+  -cppcoreguidelines-avoid-non-const-global-variables,
+  -cppcoreguidelines-interfaces-global-init,
+  -cppcoreguidelines-macro-usage,
+  -cppcoreguidelines-no-malloc,
+  -cppcoreguidelines-non-private-member-variables-in-classes,
+  -cppcoreguidelines-owning-memory,
+  -cppcoreguidelines-pro-bounds-array-to-pointer-decay,
+  -cppcoreguidelines-pro-bounds-pointer-arithmetic,
+  -cppcoreguidelines-pro-type-union-access,
+  -cppcoreguidelines-pro-type-vararg,
+  -cppcoreguidelines-pro-bounds-array-to-pointer-decay,
+  -cppcoreguidelines-special-member-functions,
+  -misc-definitions-in-headers,
+  -misc-non-private-member-variables-in-classes,
+  -readability-function-cognitive-complexity,
+  -readability-implicit-bool-conversion,
+  -readability-magic-numbers,
+  -readability-named-parameter,
+  -readability-non-const-parameter,
+  -readability-redundant-declaration
+
+InheritParentConfig: true
+
+
+CheckOptions:
+  - key:        readability-magic-numbers.IgnoredIntegerValues
+    value:      "1;2;3;4;9;32;1114111"
+  # Allow things like CHARSET_INFO cs;
+  - key:        readability-identifier-length.MinimumParameterNameLength
+    value:      1
+  - key:        readability-identifier-length.MinimumVariableNameLength
+    value:      2
diff --git a/unittest/gunit/.clang-tidy b/unittest/gunit/.clang-tidy
new file mode 100644
index 00000000000..d9ffa6faf56
--- /dev/null
+++ b/unittest/gunit/.clang-tidy
@@ -0,0 +1,26 @@
+# Copyright (c) 2024 Percona LLC and/or its affiliates. All rights reserved.
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License, version 2.0,
+# as published by the Free Software Foundation.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License, version 2.0, for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301  USA
+
+---
+Checks:
+  -cppcoreguidelines-owning-memory,
+  -cppcoreguidelines-pro-bounds-array-to-pointer-decay,
+  -readability-magic-numbers
+
+InheritParentConfig: true
+
+CheckOptions:
+  - key: readability-function-cognitive-complexity.Threshold
+    value: 100

